%define		fontdir	%{_datadir}/fonts/ja/misc
%define		b2p	%{_prefix}/X11R6/bin/bdftopcf

Name:		fonts-ja
Version:	7.x
Release: 1
License:	Distributable
Group:		User Interface/X
BuildRoot:	%{_tmppath}/%{name}-%{PACKAGE_VERSION}-root
BuildArch:	noarch
BuildPreReq:	XFree86-xfs


# from XFree86-3.3.3
# 12x24 12x24rk 7x14 7x14rk 8x16 8x16rk jiskan16 jiskan24
Source0:	xfonts_jp.tgz

# Kappa20 (20pxl)
# 10x20b 10x20m 10x20rkb 10x20rkm ipa-10x20b ipa-10x20m k20b k20m 
# http://kappa.allnet.ne.jp/20dot.fonts/
%define		Kappa	Kappa20-0.394
Source1:	http://kappa.allnet.ne.jp/20dot.fonts/%{Kappa}.tar.bz2

# Shinonome Font Family
# http://openlab.ring.gr.jp/efont/shinonome/
%define		shinonomever	0.9.6
Source3:	http://openlab.ring.gr.jp/efont/dist/shinonome/shinonome-%{shinonomever}-src.tar.bz2

# Marumoji
# maru14 maru16 maru18 7x14rkmr
# http://mlnews.com/marumoji/
Source6:	marumoji.tgz

# Kanji32 (32pxl)
Source12:	kanji32.bdf.bz2

# k14 invalid glyphs patch
# http://kappa.allnet.ne.jp/kanou/fonts/k14-patch.html
Patch0:		http://kappa.allnet.ne.jp/kanou/fonts/k14.patch

# k14 to jisx0208.1990 patch
# http://www.brl.ntt.co.jp/people/takada/goodies/k14-1990/
# http://www.brl.ntt.co.jp/people/takada/goodies/k14-1990/patch.txt
Patch1:		k14-1990.patch

# JIS X 0213-2000 fonts (14pxl, 16pxl)
# http://www.mars.sphere.ne.jp/imamura/jisx0213.html
# http://www.mars.sphere.ne.jp/imamura/K14-1.bdf.gz
# http://www.mars.sphere.ne.jp/imamura/K14-2.bdf.gz
# http://www.mars.sphere.ne.jp/imamura/jiskan16-2000-1.bdf.gz
# http://www.mars.sphere.ne.jp/imamura/jiskan16-2000-2.bdf.gz
Source15:	imamura-jisx0213.tgz

# jiskan16 JIS X 0208:1990 by Yasuoka
# http://kanji.zinbun.kyoto-u.ac.jp/~yasuoka/ftp/fonts/
Source16:	http://kanji.zinbun.kyoto-u.ac.jp/~yasuoka/ftp/fonts/jiskan16-1990.bdf.Z

# jiskan16 JIS X 0208:1997 Old Kanji
Source18:	http://kanji.zinbun.kyoto-u.ac.jp/~yasuoka/ftp/fonts/jiskano16-1997.bdf.Z
# k14 Old-Kanji
Source19:	http://www.hlla.is.tsukuba.ac.jp/~kourai/software/k14-oldkanji.tar.gz

# Warabi12 (12pxl) jisx0213
# http://www.gelgoog.org/warabi12/
%define		warabi12	warabi12-0.12a
Source20:	http://www.gelgoog.org/warabi12/archives/%{warabi12}.tar.gz

%define		vft	vine-fonttools-0.1
Source100:	%{vft}.tgz


Summary:	Japanese bitmap fonts
Requires:	XFree86-100dpi-fonts XFree86-75dpi-fonts
Prereq:		chkfontpath
Obsoletes:	XFree86-jpfonts
%description
This package contains Japanese bitmap fonts.


%prep
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%setup -q -c -a 1 -a 3 -a 6 -a 15 -a 19 -a 20 -a 100

# kanji32 is -watanabe- ( TTF watanabe-mincho is better )
# bzip2 -dc %{SOURCE12} > kanji32.bdf
gunzip -dc %{SOURCE16} > jiskan16-1990.bdf
gunzip -dc %{SOURCE18} > jiskano16-1997.bdf

%build
# rename_font() {
#   awk -vfoundry=$1 -vfamily=$2 '
# /^FOUNDRY[      ]+/ { $2 = "\"" foundry "\"" }
# /^FAMILY_NAME[       ]+/ { $2 = "\"" family "\"" }
# /^FONT[         ]+/ { split($2, n, /-/); $2 = "-" foundry "-" family; 
#                       for (i = 4; i < 16; i ++) $2 = $2 "-" n[i]; }
# { print $0 }'
# }

:
: -- STAGE 1: preparation --
:

%define chxlfd /usr/bin/perl ${RPM_BUILD_DIR}/${RPM_PACKAGE_NAME}-${RPM_PACKAGE_VERSION}/%{vft}/chbdfxlfd.pl
%define mkalias /usr/bin/perl ${RPM_BUILD_DIR}/${RPM_PACKAGE_NAME}-${RPM_PACKAGE_VERSION}/%{vft}/mkalias.pl

# make shinonome BDF
pushd shinonome-%{shinonomever}-src
  ./configure --disable-bold --disable-italic \
     --with-fontdir=$RPM_BUILD_ROOT%{fontdir}
  make bdf
popd

# rename file name of Kappa and remove bold font
pushd %{Kappa}
  sed -e 's/Bold/Medium/g' < k20b.bdf > k20.bdf
  # mv k20m.bdf k20.bdf
  mv 10x20m.bdf 10x20a.bdf
  mv 10x20rkm.bdf 10x20rk.bdf 
  # rm k20b.bdf 10x20b.bdf 10x20rkb.bdf
  rm k20b.bdf k20m.bdf 10x20b.bdf 10x20rkb.bdf
  for i in *.bdf ; do
    %{chxlfd} $i '-Kappa-.-.-.-.-.-.-.-.-.-.-.-.-.' $i.new
    mv -f $i.new $i
  done
popd

# rename file name of xfonts_jp
mv 7x14.bdf 7x14a.bdf
mv 8x16.bdf 8x16a.bdf
mv 12x24.bdf 12x24a.bdf

# k14 invalid glyphs patch
patch k14.bdf < %{PATCH0}

# k14 JIS X 0218:1990 patch
cp k14.bdf k14-1990.bdf
patch k14-1990.bdf < %{PATCH1}

# Marumoji
pushd marumoji
  for i in *.bdf ; do
    %{chxlfd} $i '-Marumoji Club-Marumoji-.-.-.-.-.-.-.-.-.-.-.-.' $i.new
    mv -f $i.new $i
  done
popd

# imamura's jiskan16 JIS X 0213:2000 hacks
pushd imamura-jisx0213
  for i in *.bdf ; do
    %{chxlfd} $i '-Imamura-Fixed-.-.-.-.-.-.-.-.-.-.-.-.' $i.new
    mv -f $i.new $i
  done
  mv K14-1.bdf k14-2000-1.bdf
  mv K14-2.bdf k14-2000-2.bdf
popd

# k14 and k14-1990 is used as Mincho
%{chxlfd} k14.bdf '-Misc-Mincho-.-.-.-.-.-.-.-.-.-.-.-.' k14.bdf.new
mv -f k14.bdf.new k14.bdf
%{chxlfd} k14-1990.bdf '-Misc-Mincho-.-.-.-.-.-.-.-.-.-.-.-.' k14-1990.bdf.new
mv -f k14-1990.bdf.new k14-1990.bdf

# oldkanji's

rm k14-oldkanji.pcf*
for i in k14-oldkanji.bdf jiskano16-1997.bdf ; do
  %{chxlfd} $i '-Misc-.-.-.-.-Old Style-.-.-.-.-.-.-.-.' $i.new
  mv -f $i.new $i
done

# Warabi12 JIS X 0213:2000 12pxl
pushd %{warabi12}
  mv warabi12-1.bdf warabi12-2000-1.bdf
popd

# move bdf to topdir
find -name "*.bdf" -path "./*/*" -exec mv {} ./ \;
# mv */*/*.bdf */*.bdf ./

# move documents to topdir
for i in */README */COPYRIGHT ; do
  mv $i `basename $i`-`dirname $i`
done

# set target font list for mkbold/mkitalic
ALL_MEDIUM_BDF_FONT="\
 shnmk12maru/ maru14/-L maru16/ \
 k14-oldkanji/ jiskano16-1997/ \
 k14-1990/-L  jiskan16-1990/ \
 warabi12-2000-1/ \
 k14-2000-1/-L     k14-2000-2/-L \
 jiskan16-2000-1/  jiskan16-2000-2/ \
 shnm6x12a/-r     shnm6x12r/-r       shnmk12/     shnmk12p/       shnmk12min/ \
 shnm8x16a/-r     shnm8x16r/-r       shnmk16/                     shnmk16min/ \
 7x14a/              7x14rk/         shnmk14/     k14/-L          shnmk14min/ \
 8x16a/              8x16rk/        jiskan16/ 
 shnm9x18a/-r     shnm9x18r/-r \
10x20a/             10x20rk/             k20/ \
12x24a/             12x24rk/        jiskan24/ \
"
#"
#kanji32/ \

# copy filter scripts (for bold/italic)
#cp %{shinonome}/tools/mkitalic .
cp shinonome-%{shinonomever}-src/tools/mkbold .

gcc $RPM_OPT_FLAGS %{vft}/mkitalic.c -o mkitalic

:
: -- STAGE 2: making roman-bold fonts --
:
for src in $ALL_MEDIUM_BDF_FONT ; do
  ./mkbold ${src#*/} -V ${src%/*}.bdf > ${src%/*}b.bdf
done

:
: -- STAGE 3: making italic-medium fonts --
:
for src in $ALL_MEDIUM_BDF_FONT ; do
  #./mkitalic -V ${src%/*}.bdf > ${src%/*}i.bdf
  ./mkitalic -s 0.2 ${src%/*}.bdf > ${src%/*}i.bdf
done

:
: -- STAGE 4: making italic-bold fonts --
:
for src in $ALL_MEDIUM_BDF_FONT ; do
  ./mkbold ${src#*/} -V ${src%/*}i.bdf > ${src%/*}bi.bdf
done

:
:
:
grep '^FONT ' *.bdf | sed -e 's/\.bdf:FONT//' > ALLFONTS.txt

##################################
# check duplicated xlfds

DUP="`cut -d' ' -f2- ALLFONTS.txt | sort | uniq -d`"
if [ ! -z "$DUP" ] ; then
  echo Duplicated XLFDs found. Please fix.
  echo ------------------------------------------
  echo "$DUP"
  exit 1
fi

cp ALLFONTS.txt mkalias.dat
# CHARSET PXL MISC FIXED MINCHO GOTHIC
# now, pixel 10 jisx0201 and pixel 20 gothic,
#      pixel 12 jisx0201 and pixel 24 gothic does not exist (fake)
%{mkalias} Misc-Fixed Alias-Fixed Alias-Gothic Alias-Mincho - \
ISO8859-1       12 shnm6x12a shnm6x12a shnm6x12a shnm6x12a \
ISO8859-1       14 7x14a 7x14a 7x14a 7x14a \
ISO8859-1       16 shnm8x16a shnm8x16a shnm8x16a shnm8x16a \
ISO8859-1	18 shnm9x18a shnm9x18a shnm9x18a shnm9x18a \
ISO8859-1       20 10x20a 10x20a - 10x20a \
ISO8859-1       24 12x24a 12x24a - 12x24a \
JISX0201.1976-0 12 shnm6x12r shnm6x12r shnm6x12r shnm6x12r \
JISX0201.1976-0 14 7x14rk 7x14rk 7x14rk 7x14rk \
JISX0201.1976-0 16 shnm8x16r shnm8x16r shnm8x16r shnm8x16r \
JISX0201.1976-0	18 shnm9x18r shnm9x18r shnm9x18r shnm9x18r \
JISX0201.1976-0 20 10x20rk 10x20rk - 10x20rk \
JISX0201.1976-0 24 12x24rk 12x24rk - 12x24rk \
JISX0208.1983-0 12 shnmk12 shnmk12 shnmk12 shnmk12min \
JISX0208.1983-0 14 shnmk14 shnmk14 shnmk14 k14 \
JISX0208.1983-0 16 shnmk16 shnmk16 shnmk16 shnmk16min \
JISX0208.1983-0 20 - - - k20 \
JISX0208.1983-0 24 - - - jiskan24 \
JISX0213.2000-1 12 warabi12-2000-1 warabi12-2000-1 warabi12-2000-1 warabi12-2000-1 \
JISX0213.2000-1 14 k14-2000-1 k14-2000-1 k14-2000-1 k14-2000-1 \
JISX0213.2000-2 14 k14-2000-2 k14-2000-2 k14-2000-2 k14-2000-2 \
JISX0213.2000-1 16 jiskan16-2000-1 jiskan16-2000-1 jiskan16-2000-1 jiskan16-2000-1 \
JISX0213.2000-2 16 jiskan16-2000-2 jiskan16-2000-2 jiskan16-2000-2 jiskan16-2000-2 \
> fonts.alias

:
: -- STAGE 5: giving the finishing touches --
:
mkdir BDFS
for src in *.bdf ; do
  %{b2p} $src | gzip -9 > ${src%.bdf}.pcf.gz
  mv $src BDFS/
done


%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{fontdir}
mv *.pcf.gz $RPM_BUILD_ROOT%{fontdir}
/usr/X11R6/bin/mkfontdir $RPM_BUILD_ROOT%{fontdir}
cp fonts.alias $RPM_BUILD_ROOT%{fontdir}/fonts.alias


%post
/usr/sbin/chkfontpath -q -a %{fontdir}

%postun
if [ "$1" = "0" ]; then
        /usr/sbin/chkfontpath -q -r %{fontdir}
fi

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root,root)
%doc COPYRIGHT* README* ALLFONTS.txt
%dir %{_datadir}/fonts/ja
%dir %{fontdir}
%{fontdir}/*


%changelog
* Tue Feb 26 2002 Tim Powers <timp@redhat.com>
- rebuilt for 7.x

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Nov 26 2001 Akira TAGOH <tagoh@redhat.com> 8.0-1
- Obsoletes XFree86-jpfonts.
- synchronize a version.
- Moved install dir from /usr/X11R6/lib/X11/fonts/japanese
  to /usr/share/fonts/ja/misc .

* Thu Nov 15 2001 Akira TAGOH <tagoh@redhat.com> 2.1-25
- Updated shinonome fonts.

* Tue Aug 14 2001 Tim Powers <timp@redhat.com>
- rebuilt to hopefully fix rpm complaints when verifying

* Wed Jun 13 2001 Akira TAGOH <tagoh@redhat.com> 2.1-22
- marge from Vine Linux's jpfonts package

* Tue Sep 12 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- modify mkitalic to be able to build when stdout is not tty
- disable -V option of mkitalic in spec

* Fri Sep 01 2000 Yukihiro Nakai <ynakai@redhat.com>
- Rebuild on 7.0J

* Mon Jun 19 2000 Daisuke SUZUKI <daisuke@redhat.com>
- 2.0-10rh
- remove knj10 font for redhat Linux

* Wed Mar  1 2000 Yasuyuki Furukawa <furukawa@vinelinux.org>
- 2.0-7, 2.0-9, 2.0-10
- updated to kaname-alter-2.8.1, k14goth-1.5

* Tue Jan 18 2000 Jun Nishii <jun@vinelinux.org>
- 2.0-6
- updated to kaname-alter-2.5

* Tue Jan 11 2000 Jun Nishii <jun@vinelinux.org>
- 2.0-5
- change group
- bzip2 many sources
- updated to kaname-alter-2.4, k14goth-1.3

* Wed Dec 29 1999 Jun Nishii <jun@vinelinux.org>
- rebuild (last build seems to be failed...)

* Fri Dec 24 1999 Jun Nishii <jun@vinelinux.org>
- removed verbose files in /usr/doc

* Thu Dec 23 1999 Jun Nishii <jun@vinelinux.org>
- kaname-alter-2.3
- k14goth-1.2

* Thu Nov 11 1999 Jun Nishii <jun@vinelinux.org>
- 1.9-1.1 try Mr.Furukawa's mkitalic

* Thu Nov 11 1999 Jun Nishii <jun@vinelinux.org>
- 1.9-1.0
- bug fix in fonts.alias

* Tue Nov 9 1999 Jun Nishii <jun@vinelinux.org>
- update to kaname-alter-2.1

* Fri Oct 15 1999 MATSUMOTO Shoji <shom@flatout.org>
- change mkitalic
- change to kaname-alter-1.3
- change to k14goth-1.0
- add kanji32

* Tue Oct  5 1999 MATSUMOTO Shoji <shom@flatout.org>
- add mkitalic
- replace k14 to k14goth

* Tue Sep 14 1999 Norihito Ohmori <ohmori@flatout.org>
- change kaname-machi font to kaname-machi kai
 
* Wed Dec  9 1998 MATSUMOTO Shoji <pje@linux.or.jp>
- create spec
